我目前正在寻找一名位于法兰克福的媒体服务架构师，与区域销售团队密切合作，作为音频和视频领域客户的联络点；并支持区域架构团队分析客户媒体业务技术架构，识别客户在音视频场景的需求和价值。

熟悉音视频领域者优先，如

直播、

视频点播、

编解码、

网络传输等。

## HEVC and AV1

HEVC (High Efficiency Video Coding) and AV1 (AOMedia Video 1) are modern video compression standards designed to improve video quality and reduce file sizes. 

### HEVC (High Efficiency Video Coding)

- **Efficiency:** HEVC provides significantly improved compression efficiency compared to its predecessor, H.264/AVC (Advanced Video Coding). It can reduce file sizes by up to 50% while maintaining the same video quality.
- **Usage:** HEVC is widely used in 4K video streaming, broadcasting, Blu-ray discs, and various video streaming platforms. It's supported by many hardware devices and software applications.
- Advantages:
  - Higher compression efficiency.
  - Better performance for high-resolution content like 4K and 8K.
- Challenges:
  - Licensing fees and patent issues.
  - Requires more processing power for encoding and decoding.

### AV1 (AOMedia Video 1)

- **Overview:** AV1 is an open-source, royalty-free video coding format developed by the Alliance for Open Media (AOMedia), a consortium that includes major tech companies like Google, Netflix, Microsoft, Amazon, and others.
- **Efficiency:** AV1 offers better compression efficiency than both H.264 and HEVC, providing approximately 30% better compression than HEVC.
- **Usage:** AV1 is increasingly being adopted for web video streaming, including platforms like YouTube, Netflix, and Facebook. It is designed to be highly efficient and versatile for a wide range of devices and network conditions.
- Advantages:
  - No licensing fees, making it attractive for widespread use.
  - Superior compression efficiency, particularly beneficial for streaming services and reducing bandwidth usage.
- Challenges:
  - Requires more computational power for encoding compared to H.264 and HEVC.
  - Less hardware support compared to HEVC, although this is rapidly changing as new devices and hardware accelerators become available.



![img](http://ff.mhrooz.xyz:4080/2024/06/20/b09674f8144d4.jpg)



Sure, here are the answers in both English and Chinese:

1. **Can you describe your experience with live streaming technologies?**
   - **English:** I have worked extensively with live streaming technologies, implementing solutions that ensure low latency and high-quality streaming. This involved configuring and optimizing RTMP, HLS, and DASH protocols. I have also worked on setting up and managing media servers such as Wowza and Nginx for live streaming.
   - **Chinese:** 我在直播技术方面有丰富的经验，实施了确保低延迟和高质量流媒体的解决方案。这包括配置和优化RTMP、HLS和DASH协议。我还曾负责设置和管理如Wowza和Nginx的媒体服务器来进行直播。
2. **What are the main differences between video on demand (VoD) and live streaming in terms of architecture and challenges?**
   - **English:** Video on demand (VoD) requires pre-encoded content stored on servers, making it easier to deliver consistent quality. Challenges include storage management and optimizing content delivery. Live streaming, on the other hand, involves real-time data transmission, which requires handling unpredictable network conditions and ensuring minimal latency. Scalability and synchronization are key architectural differences and challenges for live streaming.
   - **Chinese:** 点播（VoD）需要预先编码的内容存储在服务器上，这使得提供一致的质量更容易。挑战包括存储管理和优化内容交付。而直播则涉及实时数据传输，需要处理不可预测的网络条件并确保最低的延迟。扩展性和同步是直播在架构上主要的不同点和挑战。
3. **How have you handled encoding and decoding processes in past projects?**
   - **English:** In past projects, I have worked with FFmpeg and other encoding tools to convert raw video files into various formats and bitrates suitable for different devices and network conditions. I optimized encoding settings to balance quality and performance. For decoding, I ensured compatibility with different player software and devices, addressing issues related to codec support and performance.
   - **Chinese:** 在过去的项目中，我使用FFmpeg和其他编码工具将原始视频文件转换为适合不同设备和网络条件的各种格式和比特率。我优化了编码设置以平衡质量和性能。在解码方面，我确保与不同播放器软件和设备的兼容性，解决与编解码器支持和性能相关的问题。
4. **Explain the process of network transmission for media content and the challenges involved.**
   - **English:** Network transmission for media content involves sending encoded video/audio data from servers to end-users over the internet. This requires efficient use of bandwidth, buffering strategies to minimize latency, and ensuring data integrity and security. Challenges include dealing with network congestion, varying bandwidth availability, and ensuring smooth playback across different devices and network conditions.
   - **Chinese:** 媒体内容的网络传输涉及将编码的视频/音频数据通过互联网从服务器发送到最终用户。这需要高效使用带宽、采用缓冲策略以最小化延迟，并确保数据的完整性和安全性。挑战包括处理网络拥塞、不同带宽可用性和确保在不同设备和网络条件下的流畅播放。
5. **Describe a project where you had to analyze a customer's media technology architecture. What was your approach and outcome?**
   - **English:** In a recent project, I analyzed a client's media architecture to improve their live streaming service. I conducted a thorough assessment of their existing setup, including servers, network infrastructure, and software components. Based on the analysis, I recommended optimizing their encoding settings, upgrading network equipment, and implementing a CDN for better content delivery. The result was a significant reduction in latency and buffering issues, leading to higher user satisfaction.
   - **Chinese:** 在最近的一个项目中，我分析了客户的媒体架构以改进其直播服务。我对其现有的设置进行了全面评估，包括服务器、网络基础设施和软件组件。基于分析，我建议优化其编码设置、升级网络设备，并实施CDN以更好地传输内容。结果是显著减少了延迟和缓冲问题，用户满意度提高了很多。
6. **How do you ensure low latency and high-quality streaming in media services?**
   - **English:** Ensuring low latency and high-quality streaming involves optimizing encoding parameters, using adaptive bitrate streaming, and deploying content delivery networks (CDNs) to distribute the load. I also implement efficient buffering strategies and monitor network performance to quickly address any issues that arise.
   - **Chinese:** 确保低延迟和高质量流媒体涉及优化编码参数、使用自适应比特率流媒体，并部署内容分发网络（CDN）以分担负载。我还实施高效的缓冲策略并监控网络性能，以便快速解决出现的问题。
7. **How do you troubleshoot and resolve issues in a live streaming setup?**
   - **English:** Troubleshooting live streaming issues involves monitoring the streaming process end-to-end, from the media server to the end-user. I use tools to analyze network traffic, server performance, and client-side logs. Common issues include network congestion, server overload, and encoding errors, which I address by adjusting configurations, scaling resources, and applying patches as needed.
   - **Chinese:** 排查直播问题涉及端到端监控从媒体服务器到最终用户的流媒体过程。我使用工具分析网络流量、服务器性能和客户端日志。常见问题包括网络拥塞、服务器过载和编码错误，我通过调整配置、扩展资源和根据需要应用补丁来解决这些问题。
8. **Give an example of a technical challenge you faced in a media-related project and how you overcame it.**
   - **English:** One major challenge was dealing with latency in a global live streaming project. The solution involved deploying multiple edge servers globally and using a CDN to cache content closer to users. Additionally, I optimized the encoding settings to reduce processing time and implemented adaptive bitrate streaming to ensure smooth playback under varying network conditions.
   - **Chinese:** 一个重大挑战是在全球直播项目中处理延迟问题。解决方案包括在全球部署多个边缘服务器并使用CDN将内容缓存到更接近用户的地方。此外，我优化了编码设置以减少处理时间，并实施自适应比特率流媒体以确保在不同网络条件下的流畅播放。
9. **How do you handle communication and collaboration with regional sales teams and technical teams?**
   - **English:** I ensure clear and consistent communication by holding regular meetings, using collaboration tools like Slack and Jira, and documenting processes and updates thoroughly. I also make an effort to understand the sales team's goals and technical team's constraints, facilitating a collaborative environment where both sides can work towards common objectives.
   - **Chinese:** 我通过定期召开会议、使用Slack和Jira等协作工具以及全面记录过程和更新来确保清晰和一致的沟通。我还努力理解销售团队的目标和技术团队的限制，促进一个双方能够共同努力实现共同目标的协作环境。
10. **Describe a situation where you had to explain complex technical details to a non-technical customer. How did you ensure they understood?**
    - **English:** I once had to explain the benefits of adaptive bitrate streaming to a customer. I used analogies and visual aids to break down the concept into simpler terms, comparing it to adjusting the water flow in a shower to maintain a comfortable temperature. By relating technical details to everyday experiences, I ensured the customer grasped the value and functionality of the technology.
    - **Chinese:** 我曾经需要向客户解释自适应比特率流媒体的好处。我使用类比和视觉辅助工具将概念分解为更简单的术语，将其比作调整淋浴中的水流以保持舒适的温度。通过将技术细节与日常经验联系起来，我确保客户理解了技术的价值和功能。
11. **How do you prioritize tasks and manage your time when working on multiple projects?**
    - **English:** I use project management tools like Asana and Trello to organize tasks and set clear deadlines. I prioritize tasks based on urgency and impact, breaking down larger projects into manageable milestones. Regular check-ins and progress reviews help me stay on track and adjust priorities as needed.
    - **Chinese:** 我使用Asana和Trello等项目管理工具来组织任务并设定明确的截止日期。我根据紧急性和影响优先排序任务，将较大的项目分解为可管理的里程碑。定期检查和进度评审帮助我保持在轨道上并根据需要调整优先级。
12. **What are the current trends and advancements in the audio and video streaming industry?**
    - **English:** Current trends include the rise of 4K and 8K streaming, the adoption of HEVC and AV1 codecs for better compression, and the use of AI for content personalization and quality enhancement. There's also a growing focus on low-latency streaming for real-time interaction and the integration of augmented and virtual reality into streaming services.
    - **Chinese:** 当前的趋势包括4K和8K流媒体的兴起、采用HEVC和AV1编解码器以实现更好的压缩，以及使用AI进行内容个性化和质量提升。还越来越关注用于实时交互的低延迟流媒体和将增强现实和虚拟现实集成到流媒体服务中。
13. **How do you stay updated with the latest technologies and best practices in media services?**
    - **English:** I stay updated by following industry blogs, attending webinars and conferences, participating in online forums, and taking courses on platforms like Coursera and Udemy. I also subscribe to newsletters from leading media technology companies and organizations.
    - **Chinese:** 我通过关注行业博客、参加网络研讨会和会议、参与在线论坛以及在Coursera和Udemy等平台上学习课程来保持更新。我还订阅领先媒体技术公司和组织的新闻简报。
14. **Why are you interested in working at Tencent, and how do you think your skills align with this role?**
    - **English:** I am interested in working at Tencent because of its innovative approach to media services and its global reach. My experience in live streaming, encoding/decoding, and network transmission aligns well with the requirements of this role. I am excited about the opportunity to contribute to Tencent's growth and help deliver high-quality media experiences to users worldwide.
    - **Chinese:** 我对在腾讯工作感兴趣，因为它在媒体服务方面的创新方法和全球影响力。我的直播、编码/解码和网络传输经验非常符合这个角色的要求。我很高兴有机会为腾讯的成长做出贡献，并帮助向全球用户提供高质量的媒体体验。
15. **How do you see the future of media services evolving, and what role do you think Tencent will play in this evolution?**
    - **English:** The future of media services will likely see more immersive and interactive content, driven by advancements in AR/VR and AI. Tencent, with its strong technology foundation and innovative culture, is well-positioned to lead in this space. I believe Tencent will continue to push the boundaries of media experiences, setting new standards for quality and user engagement.
    - **Chinese:** 媒体服务的未来可能会看到更多沉浸式和互动内容，这由AR/VR和AI的进步驱动。腾讯凭借其强大的技术基础和创新文化，在这一领域处于领先地位。我相信腾讯将继续推动媒体体验的边界，树立新的质量和用户参与标准。

## 直播协议

本期我们详细讨论直播的相关协议，包括：HTTP-FLV、HLS、RTMP、Web-RTC、RTSP等等。
我们将会详细介绍这些协议的工作原理、应用场景、及延迟的原因。
我们按这样的顺序讨论​：

- RTMP、HTTP-FLV
- HLS
- Web-RTC
- RTSP

### 一、RTMP、HTTP-FLV

#### 1.1 我们先讨论RTMP

RTMP协议是既可以推流、也可以拉流的协议。
RTMP地址是rtmp://开头的，且推流地址与播放地址是一样的。
但是由于浏览器摒弃了Flash播放器，而且据说高并发下可能会出现一些不稳定的问题，**所以RTMP一般只用作直播源推流、推流到直播CDN等场景。**

![img](http://ff.mhrooz.xyz:4080/2024/06/20/e6c1c1f69c815.png)

**RTMP协议需要特定的流媒体服务软件，如SRS、加入了RTMP插件的Nginx等。**
在往期直播工作原理中讨论过，此类流媒体服务软件实际上就是音视频数据的中转站，**数据一般只在内存中循环覆盖，不会写入磁盘。**
**RTMP协议的延迟是比较低的，大概在1-3秒左右。**
RTMP通信是建立在**TCP长连接通道上**的，**在封装音视频数据时会强制切片，限制每个数据包的大小。**
强制切片**也一定程度保证了实时性**。有一定的弱网抵抗能力，因为每个数据包都不会太大，所以当某个数据包校验失败时，重新发送的成本不会太大，**但也由于合并数据包会加大CPU压力，所以是有一定的性能消耗的。**
RTMP协议还有一些变种协议，如RTMPT、RTMPS等，这里不作展开讨论。

![img](http://ff.mhrooz.xyz:4080/2024/06/20/ef6fda8227861.png)

#### 1.2 我们再讨论HTTP-FLV协议

地址是http://开头的，是基于HTTP协议的HTTP-FLV可以简单地理解为RTMP的HTTP协议版本。功能和工作原理上是相似的，上面提到的RTMP切片数据功能HTTP-FLV也是有的。
但是，HTTP-FLV协议一般只能用作拉流观看。
HTTP-FLV协议的延迟也是比较低的，大概在1-3秒左右，**但实际体验下来 HTTP-FLV延迟会略高于RTMP**，但是HTTP-FLV相对RTMP适配更多的播放场景。

![img](http://ff.mhrooz.xyz:4080/2024/06/20/05b09455e4553.png)

HTTP-FLV直播流一般需要需加入插件才能播放，如网页需要引入flv.js后，浏览器才能播放。HTTP-FLV直播流，这里需要特别感谢B站开源的flv.js，它促进了HTTP-FLV在浏览器的普及。

HTTP-FLV协议需要特定的流媒体服务软件，如加入了HTTP-FLV插件的Nginx等。Nginx的HTTP-FLV插件是包含RTMP功能的，所以一般HTTP-FLV的流媒体服务，推流是以RTMP协议，拉流是用HTTP-FLV协议。

![img](http://ff.mhrooz.xyz:4080/2024/06/20/e92a38c12e2b0.png)

现在比较流行的方案是，直播源推流是RTMP协议，直播拉流观看是HTTP-FLV协议。

![img](http://ff.mhrooz.xyz:4080/2024/06/20/b25de7cea3aad.png)

### 二、HLS 

HLS协议一般只用作拉流观看，但是从严格意义上讲，HLS协议并不是流式协议。
它工作原理很简单，就是通过HTTP协议下载静态文件。
不同的是，HLS协议的文件由两部分组成，一是多个只有几秒长度的.ts碎片视频文件，另一个是记录这些视频文件地址的.m3u8索引文件，且这些静态文件都是直接写入磁盘的。
更具体的说，HLS观看地址是以http://开头、.m3u8结尾的，实际上这个地址就是索引文件的地址，客户端获取到索引文件后，就可以下载对应的碎片视频文件并开始播放了。
由于HLS协议实际上是通过HTTP协议请求文件的，且HLS相关文件是直接写入磁盘的，所以并不需要特殊的流媒体服务软件，使用Nginx等HTTP服务就可以了。
HLS协议可以用于点播和直播观看，其适配多种播放场景，一般加入插件就可以播放了，如网页加入HLS的js插件就可以播放了，苹果设备是原生支持HLS协议的。

![img](http://ff.mhrooz.xyz:4080/2024/06/20/ed3fe8031df3d.png)

点播的场景下，也就是普通网络视频观看的场景下。
.m3u8索引文件会记录所有的碎片视频文件地址，HLS在点播的场景下，优势是更加明显的。
由于HLS的相关文件是无状态的静态文件，且每个文件的大小是有限的，所以负载均衡、CDN加速的效果更佳明显。
HLS协议的点播视频，会比.mp4、.flv的视频更快地播放出来，且在加载中跳转视频也会更加顺滑。

![img](http://ff.mhrooz.xyz:4080/2024/06/20/dcfa46b2d0edb.png)

直播的场景下，转码软件可以直接生成HLS相关文件到磁盘，客户端通过HTTP服务下载文件即可。
另外，也可以在Nginx加入RTMP插件，转码软件以RTMP协议推流到Nginx，再由Nginx生成HLS相关文件。
其中，后一种方案更加推荐，因为它对于前期研发和后期对接直播CDN的过度更加顺滑。

![img](http://ff.mhrooz.xyz:4080/2024/06/20/216491dfe8ce4.png)

另外，直播场景下的HLS相关文件与点播是有些不同的。
视频流数据每几秒会打包成一个以.ts为后缀的碎片视频文件，每生成一个新的视频文件都会同步更新.m3u8索引文件。
且碎片视频文件的个数是有上限的，当达到上限后，默认会将最旧的视频文件删除且更新.m3u8索引文件。
所以在直播的场景下，客户端也需要不断定时重新获取.m3u8索引文件。

![img](http://ff.mhrooz.xyz:4080/2024/06/20/a4d4839aa7973.png)

HLS协议在直播的场景下是没什么优势的。
虽然HLS协议的直播流也可以适配很多播放场景，但是由于需要生成静态文件，直播延迟很大，大概在5-30秒左右，使用直播CDN的话，由于边缘节点同步等问题，直播延迟甚至可能会达到1分钟左右。
当然HLS协议也有一定的优势，在**直播时移**，也就是直播转点播，或者录播，也就是点播转直播的场景， 理论上只需要修改索引文件就可以了。

![img](http://ff.mhrooz.xyz:4080/2024/06/20/55e6b85f68a8d.png)

另外，HLS协议的.m3u8索引文件支持二级索引，就是高清、标清、流畅等多个观看地址可以整合到一个索引文件。播放器可以根据当前带宽自动切换不同的观看地址，大部分网页播放器的“自动”也是因为这个。

![img](http://ff.mhrooz.xyz:4080/2024/06/20/506577bf82e95.png)

这里补充一个HLS协议的小知识点。
由于HLS协议的视频文件、索引文件都是直接写入磁盘的 ，所以如果长时间且多个直播流同时处理，会造成磁盘写入压力过大，机械磁盘可能会磁道会损坏，固态硬盘的寿命会加速衰减。
这种情况下，最好挂载一段内存空间作为HLS相关文件的写入位置，则不会造成磁盘写入压力过大的问题。

![img](http://ff.mhrooz.xyz:4080/2024/06/20/8e6bd916bcb5c.png)

### 三、WebRTC协议

WebRTC协议其实并不是为了直播场景而设计的，WebRTC是一种点对点的视频/语音通话协议。
由于WebRTC是基于UDP的，建立通信后，会不断以流式发送数据，所以延迟会比RTMP还要低。
在一些交互性较高的直播场景，如直播带货等场景，会使用WebRTC作为推流和观看协议 WebRTC的延迟理论上可以达到1秒内。

![img](http://ff.mhrooz.xyz:4080/2024/06/20/bf1b737b8e9b9.png)

WebRTC协议支持推流和拉流，地址一般是以webrtc://开头的，且推流和拉流地址一般也是一样的。
WebRTC虽然是点对点的协议，但是应用在直播场景的话，是需要搭建WebRTC服务器作为流媒体服务的，流媒体服务软件可以使用SRS。

![img](http://ff.mhrooz.xyz:4080/2024/06/20/0225dbf41e685.png)

![img](http://ff.mhrooz.xyz:4080/2024/06/20/263eba444fe5a.png)

当然，最大码率的限制需要看具体场景，有时候为了节省手机客户端的流量，可能会设置很低的最大码率。

一般来说，1920X1080分辨率、30帧、H264编码的视频，最大码率设置为2或3Mbps一般都是清晰



![img](http://ff.mhrooz.xyz:4080/2024/06/21/93d7d855f0781.jpg)

![img](http://ff.mhrooz.xyz:4080/2024/06/21/64a588802a555.jpg)

![image-20240621092306573](http://ff.mhrooz.xyz:4080/2024/06/21/6124ac2e4c72e.png)

 

电商直播,高并发秒发,实时性/互动,推流,分发,拉流

RTMP

H264 265

风控 ai+人工

评论实时性, 长链接,集群

多线程并行

允许一定的丢失,可以随机选取

![image-20240621092711257](http://ff.mhrooz.xyz:4080/2024/06/21/1e95d4e14a3ef.png)

## 自我介绍

我是马含章,目前在德国慕尼黑大学攻读计算机硕士学位.硕士期间主要研究人工智能,尤其是生成式模型,比如目前生图比较流行的diffusion模型,以及一些云服务相关的内容.

I am Hanzhang Ma, currently pursuing a Master's degree in Computer Science at Ludwig Maximilian University of Munich in Germany. During my Master's studies, I am mainly researching artificial intelligence, particularly generative models, such as the currently popular diffusion models, as well as some cloud service-related topics.

我一直对云服务比较感兴趣,在家里也搭建了一台小型的服务器作为自己的业余爱好.目前服务器主要作为我看电视剧,电影用的服务器,还运行了一些诸如个人网站, git仓库,在线图库,远程桌面,智能家居之类的服务.我从上大学到现在,我也一直在使用腾讯云的服务,比如域名解析,云服务器等等.

I have always been interested in cloud services, and as a hobby, I have set up a small server at home. Currently, the server mainly serves as my media server for watching TV shows and movies, and it also runs various services such as a blog website, a Git repository, online photo gallery, Remote Desktop, and smart home applications. Since starting university, I have also been using Tencent Cloud services, such as domain name resolution and cloud servers.